#!/usr/bin/perl -w
#package nodefield1_06
use Test::More no_plan;
use strict;

BEGIN {
	$| = 1;
	chdir 't' if -d 't';
	unshift @INC, '../lib';
	use_ok 'Weed';
	use_ok 'TestNodeFields';
}

ok my $testNode = new SFNode( new TestNode );

ok !tied ${ tied $testNode->getValue->getTiedField('mfbool') };
ok !tied ${ tied $testNode->getValue->getTiedField('mfcolor') };
ok !tied ${ tied $testNode->getValue->getTiedField('mfcolorrgba') };
ok !tied ${ tied $testNode->getValue->getTiedField('mfdouble') };
ok !tied ${ tied $testNode->getValue->getTiedField('mffloat') };
ok !tied ${ tied $testNode->getValue->getTiedField('mfimage') };
ok !tied ${ tied $testNode->getValue->getTiedField('mfint32') };
ok !tied ${ tied $testNode->getValue->getTiedField('mfnode') };
ok !tied ${ tied $testNode->getValue->getTiedField('mfrotation') };
ok !tied ${ tied $testNode->getValue->getTiedField('mfstring') };
ok !tied ${ tied $testNode->getValue->getTiedField('mftime') };
ok !tied ${ tied $testNode->getValue->getTiedField('mfvec2d') };
ok !tied ${ tied $testNode->getValue->getTiedField('mfvec2f') };
ok !tied ${ tied $testNode->getValue->getTiedField('mfvec3d') };
ok !tied ${ tied $testNode->getValue->getTiedField('mfvec3f') };
ok !tied ${ tied $testNode->getValue->getTiedField('mfvec4d') };
ok !tied ${ tied $testNode->getValue->getTiedField('mfvec4f') };

ok !tied ${ tied $testNode->getValue->getTiedField('sfbool') };
ok !tied ${ tied $testNode->getValue->getTiedField('sfcolor') };
ok !tied ${ tied $testNode->getValue->getTiedField('sfcolorrgba') };
ok !tied ${ tied $testNode->getValue->getTiedField('sfdouble') };
ok !tied ${ tied $testNode->getValue->getTiedField('sffloat') };
ok !tied ${ tied $testNode->getValue->getTiedField('sfimage') };
ok !tied ${ tied $testNode->getValue->getTiedField('sfint32') };
ok !tied ${ tied $testNode->getValue->getTiedField('sfnode') };
ok !tied ${ tied $testNode->getValue->getTiedField('sfrotation') };
ok !tied ${ tied $testNode->getValue->getTiedField('sfstring') };
ok !tied ${ tied $testNode->getValue->getTiedField('sftime') };
ok !tied ${ tied $testNode->getValue->getTiedField('sfvec2d') };
ok !tied ${ tied $testNode->getValue->getTiedField('sfvec2f') };
ok !tied ${ tied $testNode->getValue->getTiedField('sfvec3d') };
ok !tied ${ tied $testNode->getValue->getTiedField('sfvec3f') };
ok !tied ${ tied $testNode->getValue->getTiedField('sfvec4d') };
ok !tied ${ tied $testNode->getValue->getTiedField('sfvec4f') };

isa_ok ${ tied $testNode->getValue->getTiedField('mfbool') },      'MFBool';
isa_ok ${ tied $testNode->getValue->getTiedField('mfcolor') },     'MFColor';
isa_ok ${ tied $testNode->getValue->getTiedField('mfcolorrgba') }, 'MFColorRGBA';
isa_ok ${ tied $testNode->getValue->getTiedField('mfdouble') },    'MFDouble';
isa_ok ${ tied $testNode->getValue->getTiedField('mffloat') },     'MFFloat';
isa_ok ${ tied $testNode->getValue->getTiedField('mfimage') },     'MFImage';
isa_ok ${ tied $testNode->getValue->getTiedField('mfint32') },     'MFInt32';
isa_ok ${ tied $testNode->getValue->getTiedField('mfnode') },      'MFNode';
isa_ok ${ tied $testNode->getValue->getTiedField('mfrotation') },  'MFRotation';
isa_ok ${ tied $testNode->getValue->getTiedField('mfbool') },      'MFBool';
isa_ok ${ tied $testNode->getValue->getTiedField('mfcolor') },     'MFColor';
isa_ok ${ tied $testNode->getValue->getTiedField('mfcolorrgba') }, 'MFColorRGBA';
isa_ok ${ tied $testNode->getValue->getTiedField('mfdouble') },    'MFDouble';
isa_ok ${ tied $testNode->getValue->getTiedField('mffloat') },     'MFFloat';
isa_ok ${ tied $testNode->getValue->getTiedField('mfimage') },     'MFImage';
isa_ok ${ tied $testNode->getValue->getTiedField('mfint32') },     'MFInt32';
isa_ok ${ tied $testNode->getValue->getTiedField('mfnode') },      'MFNode';
isa_ok ${ tied $testNode->getValue->getTiedField('mfrotation') },  'MFRotation';
isa_ok ${ tied $testNode->getValue->getTiedField('mfstring') },    'MFString';
isa_ok ${ tied $testNode->getValue->getTiedField('mftime') },      'MFTime';
isa_ok ${ tied $testNode->getValue->getTiedField('mfvec2d') },     'MFVec2d';
isa_ok ${ tied $testNode->getValue->getTiedField('mfvec2f') },     'MFVec2f';
isa_ok ${ tied $testNode->getValue->getTiedField('mfvec3d') },     'MFVec3d';
isa_ok ${ tied $testNode->getValue->getTiedField('mfvec3f') },     'MFVec3f';
isa_ok ${ tied $testNode->getValue->getTiedField('mfvec4d') },     'MFVec4d';
isa_ok ${ tied $testNode->getValue->getTiedField('mfvec4f') },     'MFVec4f';

isa_ok ${ tied $testNode->getValue->getTiedField('sfbool') },      'SFBool';
isa_ok ${ tied $testNode->getValue->getTiedField('sfcolor') },     'SFColor';
isa_ok ${ tied $testNode->getValue->getTiedField('sfcolorrgba') }, 'SFColorRGBA';
isa_ok ${ tied $testNode->getValue->getTiedField('sfdouble') },    'SFDouble';
isa_ok ${ tied $testNode->getValue->getTiedField('sffloat') },     'SFFloat';
isa_ok ${ tied $testNode->getValue->getTiedField('sfimage') },     'SFImage';
isa_ok ${ tied $testNode->getValue->getTiedField('sfint32') },     'SFInt32';
isa_ok ${ tied $testNode->getValue->getTiedField('sfnode') },      'SFNode';
isa_ok ${ tied $testNode->getValue->getTiedField('sfrotation') },  'SFRotation';
isa_ok ${ tied $testNode->getValue->getTiedField('sfstring') },    'SFString';
isa_ok ${ tied $testNode->getValue->getTiedField('sftime') },      'SFTime';
isa_ok ${ tied $testNode->getValue->getTiedField('sfvec2d') },     'SFVec2d';
isa_ok ${ tied $testNode->getValue->getTiedField('sfvec2f') },     'SFVec2f';
isa_ok ${ tied $testNode->getValue->getTiedField('sfvec3d') },     'SFVec3d';
isa_ok ${ tied $testNode->getValue->getTiedField('sfvec3f') },     'SFVec3f';
isa_ok ${ tied $testNode->getValue->getTiedField('mfstring') },    'MFString';
isa_ok ${ tied $testNode->getValue->getTiedField('mftime') },      'MFTime';
isa_ok ${ tied $testNode->getValue->getTiedField('mfvec2d') },     'MFVec2d';
isa_ok ${ tied $testNode->getValue->getTiedField('mfvec2f') },     'MFVec2f';
isa_ok ${ tied $testNode->getValue->getTiedField('mfvec3d') },     'MFVec3d';
isa_ok ${ tied $testNode->getValue->getTiedField('mfvec3f') },     'MFVec3f';
isa_ok ${ tied $testNode->getValue->getTiedField('sfbool') },      'SFBool';
isa_ok ${ tied $testNode->getValue->getTiedField('sfcolor') },     'SFColor';
isa_ok ${ tied $testNode->getValue->getTiedField('sfcolorrgba') }, 'SFColorRGBA';
isa_ok ${ tied $testNode->getValue->getTiedField('sfdouble') },    'SFDouble';
isa_ok ${ tied $testNode->getValue->getTiedField('sffloat') },     'SFFloat';
isa_ok ${ tied $testNode->getValue->getTiedField('sfimage') },     'SFImage';
isa_ok ${ tied $testNode->getValue->getTiedField('sfint32') },     'SFInt32';
isa_ok ${ tied $testNode->getValue->getTiedField('sfnode') },      'SFNode';
isa_ok ${ tied $testNode->getValue->getTiedField('sfrotation') },  'SFRotation';
isa_ok ${ tied $testNode->getValue->getTiedField('sfstring') },    'SFString';
isa_ok ${ tied $testNode->getValue->getTiedField('sftime') },      'SFTime';
isa_ok ${ tied $testNode->getValue->getTiedField('sfvec2d') },     'SFVec2d';
isa_ok ${ tied $testNode->getValue->getTiedField('sfvec2f') },     'SFVec2f';
isa_ok ${ tied $testNode->getValue->getTiedField('sfvec3d') },     'SFVec3d';
isa_ok ${ tied $testNode->getValue->getTiedField('sfvec3f') },     'SFVec3f';
isa_ok ${ tied $testNode->getValue->getTiedField('sfvec4d') },     'SFVec4d';
isa_ok ${ tied $testNode->getValue->getTiedField('sfvec4f') },     'SFVec4f';

isa_ok tied $testNode->getValue->getTiedField('mfbool'),      'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfcolor'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfcolorrgba'), 'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfdouble'),    'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mffloat'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfimage'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfint32'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfnode'),      'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfrotation'),  'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfstring'),    'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mftime'),      'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfvec2d'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfvec2f'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfvec3d'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfvec3f'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfbool'),      'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfcolor'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfcolorrgba'), 'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfdouble'),    'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sffloat'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfimage'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfint32'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfnode'),      'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfrotation'),  'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfstring'),    'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sftime'),      'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfvec2d'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfvec2f'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfvec3d'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfvec3f'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfvec4d'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfvec4f'),     'Weed::Tie::Field';

isa_ok tied $testNode->getValue->getTiedField('mfbool'),      'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfcolor'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfcolorrgba'), 'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfdouble'),    'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mffloat'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfimage'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfint32'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfnode'),      'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfrotation'),  'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfstring'),    'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mftime'),      'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfvec2d'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfvec2f'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfvec3d'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('mfvec3f'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfbool'),      'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfcolor'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfcolorrgba'), 'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfdouble'),    'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sffloat'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfimage'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfint32'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfnode'),      'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfrotation'),  'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfstring'),    'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sftime'),      'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfvec2d'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfvec2f'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfvec3d'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfvec3f'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfvec4d'),     'Weed::Tie::Field';
isa_ok tied $testNode->getValue->getTiedField('sfvec4f'),     'Weed::Tie::Field';

#ok tied $weed->getValue->getTiedField('metadata');
ok tied $testNode->getValue->getTiedField('mfbool');
ok tied $testNode->getValue->getTiedField('mfcolor');
ok tied $testNode->getValue->getTiedField('mfcolorrgba');
ok tied $testNode->getValue->getTiedField('mfdouble');
ok tied $testNode->getValue->getTiedField('mffloat');
ok tied $testNode->getValue->getTiedField('mfimage');
ok tied $testNode->getValue->getTiedField('mfint32');
ok tied $testNode->getValue->getTiedField('mfnode');
ok tied $testNode->getValue->getTiedField('mfrotation');
ok tied $testNode->getValue->getTiedField('mfstring');
ok tied $testNode->getValue->getTiedField('mftime');
ok tied $testNode->getValue->getTiedField('mfvec2d');
ok tied $testNode->getValue->getTiedField('mfvec2f');
ok tied $testNode->getValue->getTiedField('mfvec3d');
ok tied $testNode->getValue->getTiedField('mfvec3f');
ok tied $testNode->getValue->getTiedField('mfvec4d');
ok tied $testNode->getValue->getTiedField('mfvec4f');

ok tied $testNode->getValue->getTiedField('sfbool');
ok tied $testNode->getValue->getTiedField('sfcolor');
ok tied $testNode->getValue->getTiedField('sfcolorrgba');
ok tied $testNode->getValue->getTiedField('sfdouble');
ok tied $testNode->getValue->getTiedField('sffloat');
ok tied $testNode->getValue->getTiedField('sfimage');
ok tied $testNode->getValue->getTiedField('sfint32');
ok tied $testNode->getValue->getTiedField('sfnode');
ok tied $testNode->getValue->getTiedField('sfrotation');
ok tied $testNode->getValue->getTiedField('sfstring');
ok tied $testNode->getValue->getTiedField('sftime');
ok tied $testNode->getValue->getTiedField('sfvec2d');
ok tied $testNode->getValue->getTiedField('sfvec2f');
ok tied $testNode->getValue->getTiedField('sfvec3d');
ok tied $testNode->getValue->getTiedField('sfvec3f');
ok tied $testNode->getValue->getTiedField('sfvec4d');
ok tied $testNode->getValue->getTiedField('sfvec4f');

#is ref $weed->getValue->getField('metadata'), 'SFNode';
is ref $testNode->getValue->getField('mfbool'),      'MFBool';
is ref $testNode->getValue->getField('mfcolor'),     'MFColor';
is ref $testNode->getValue->getField('mfcolorrgba'), 'MFColorRGBA';
is ref $testNode->getValue->getField('mfdouble'),    'MFDouble';
is ref $testNode->getValue->getField('mffloat'),     'MFFloat';
is ref $testNode->getValue->getField('mfimage'),     'MFImage';
is ref $testNode->getValue->getField('mfint32'),     'MFInt32';
is ref $testNode->getValue->getField('mfnode'),      'MFNode';
is ref $testNode->getValue->getField('mfrotation'),  'MFRotation';
is ref $testNode->getValue->getField('mfstring'),    'MFString';
is ref $testNode->getValue->getField('mftime'),      'MFTime';
is ref $testNode->getValue->getField('mfvec2d'),     'MFVec2d';
is ref $testNode->getValue->getField('mfvec2f'),     'MFVec2f';
is ref $testNode->getValue->getField('mfvec3d'),     'MFVec3d';
is ref $testNode->getValue->getField('mfvec3f'),     'MFVec3f';
is ref $testNode->getValue->getField('mfvec4d'),     'MFVec4d';
is ref $testNode->getValue->getField('mfvec4f'),     'MFVec4f';

is ref $testNode->getValue->getField('sfbool'),      'SFBool';
is ref $testNode->getValue->getField('sfcolor'),     'SFColor';
is ref $testNode->getValue->getField('sfcolorrgba'), 'SFColorRGBA';
is ref $testNode->getValue->getField('sfdouble'),    'SFDouble';
is ref $testNode->getValue->getField('sffloat'),     'SFFloat';
is ref $testNode->getValue->getField('sfimage'),     'SFImage';
is ref $testNode->getValue->getField('sfint32'),     'SFInt32';
is ref $testNode->getValue->getField('sfnode'),      'SFNode';
is ref $testNode->getValue->getField('sfrotation'),  'SFRotation';
is ref $testNode->getValue->getField('sfstring'),    'SFString';
is ref $testNode->getValue->getField('sftime'),      'SFTime';
is ref $testNode->getValue->getField('sfvec2d'),     'SFVec2d';
is ref $testNode->getValue->getField('sfvec2f'),     'SFVec2f';
is ref $testNode->getValue->getField('sfvec3d'),     'SFVec3d';
is ref $testNode->getValue->getField('sfvec3f'),     'SFVec3f';
is ref $testNode->getValue->getField('sfvec4d'),     'SFVec4d';
is ref $testNode->getValue->getField('sfvec4f'),     'SFVec4f';

isa_ok $testNode->getValue->getField('mfbool'),      'MFBool';
isa_ok $testNode->getValue->getField('mfcolor'),     'MFColor';
isa_ok $testNode->getValue->getField('mfcolorrgba'), 'MFColorRGBA';
isa_ok $testNode->getValue->getField('mfdouble'),    'MFDouble';
isa_ok $testNode->getValue->getField('mffloat'),     'MFFloat';
isa_ok $testNode->getValue->getField('mfimage'),     'MFImage';
isa_ok $testNode->getValue->getField('mfint32'),     'MFInt32';
isa_ok $testNode->getValue->getField('mfnode'),      'MFNode';
isa_ok $testNode->getValue->getField('mfrotation'),  'MFRotation';
isa_ok $testNode->getValue->getField('mfstring'),    'MFString';
isa_ok $testNode->getValue->getField('mftime'),      'MFTime';
isa_ok $testNode->getValue->getField('mfvec2d'),     'MFVec2d';
isa_ok $testNode->getValue->getField('mfvec2f'),     'MFVec2f';
isa_ok $testNode->getValue->getField('mfvec3d'),     'MFVec3d';
isa_ok $testNode->getValue->getField('mfvec3f'),     'MFVec3f';
isa_ok $testNode->getValue->getField('mfvec4d'),     'MFVec4d';
isa_ok $testNode->getValue->getField('mfvec4f'),     'MFVec4f';

isa_ok $testNode->getValue->getField('sfbool'),      'SFBool';
isa_ok $testNode->getValue->getField('sfcolor'),     'SFColor';
isa_ok $testNode->getValue->getField('sfcolorrgba'), 'SFColorRGBA';
isa_ok $testNode->getValue->getField('sfdouble'),    'SFDouble';
isa_ok $testNode->getValue->getField('sffloat'),     'SFFloat';
isa_ok $testNode->getValue->getField('sfimage'),     'SFImage';
isa_ok $testNode->getValue->getField('sfint32'),     'SFInt32';
isa_ok $testNode->getValue->getField('sfnode'),      'SFNode';
isa_ok $testNode->getValue->getField('sfrotation'),  'SFRotation';
isa_ok $testNode->getValue->getField('sfstring'),    'SFString';
isa_ok $testNode->getValue->getField('sftime'),      'SFTime';
isa_ok $testNode->getValue->getField('sfvec2d'),     'SFVec2d';
isa_ok $testNode->getValue->getField('sfvec2f'),     'SFVec2f';
isa_ok $testNode->getValue->getField('sfvec3d'),     'SFVec3d';
isa_ok $testNode->getValue->getField('sfvec3f'),     'SFVec3f';
isa_ok $testNode->getValue->getField('sfvec4d'),     'SFVec4d';
isa_ok $testNode->getValue->getField('sfvec4f'),     'SFVec4f';

#is ref $weed->metadata, 'SFNode';
is ref $testNode->mfbool,      'MFBool';
is ref $testNode->mfcolor,     'MFColor';
is ref $testNode->mfcolorrgba, 'MFColorRGBA';
is ref $testNode->mfdouble,    'MFDouble';
is ref $testNode->mffloat,     'MFFloat';
is ref $testNode->mfimage,     'MFImage';
is ref $testNode->mfint32,     'MFInt32';
is ref $testNode->mfnode,      'MFNode';
is ref $testNode->mfrotation,  'MFRotation';
is ref $testNode->mfstring,    'MFString';
is ref $testNode->mftime,      'MFTime';
is ref $testNode->mfvec2d,     'MFVec2d';
is ref $testNode->mfvec2f,     'MFVec2f';
is ref $testNode->mfvec3d,     'MFVec3d';
is ref $testNode->mfvec3f,     'MFVec3f';
is ref $testNode->mfvec4d,     'MFVec4d';
is ref $testNode->mfvec4f,     'MFVec4f';

is ref $testNode->sfbool,      'SFBool';
is ref $testNode->sfcolor,     'SFColor';
is ref $testNode->sfcolorrgba, 'SFColorRGBA';
is ref $testNode->sfdouble,    'SFDouble';
is ref $testNode->sffloat,     'SFFloat';
is ref $testNode->sfimage,     'SFImage';
is ref $testNode->sfint32,     'SFInt32';
is ref $testNode->sfnode,      'SFNode';
is ref $testNode->sfrotation,  'SFRotation';
is ref $testNode->sfstring,    'SFString';
is ref $testNode->sftime,      'SFTime';
is ref $testNode->sfvec2d,     'SFVec2d';
is ref $testNode->sfvec2f,     'SFVec2f';
is ref $testNode->sfvec3d,     'SFVec3d';
is ref $testNode->sfvec3f,     'SFVec3f';
is ref $testNode->sfvec4d,     'SFVec4d';
is ref $testNode->sfvec4f,     'SFVec4f';

#isa_ok $weed->metadata, 'X3DField';
isa_ok $testNode->mfbool,      'X3DField';
isa_ok $testNode->mfcolor,     'X3DField';
isa_ok $testNode->mfcolorrgba, 'X3DField';
isa_ok $testNode->mfdouble,    'X3DField';
isa_ok $testNode->mffloat,     'X3DField';
isa_ok $testNode->mfimage,     'X3DField';
isa_ok $testNode->mfint32,     'X3DField';
isa_ok $testNode->mfnode,      'X3DField';
isa_ok $testNode->mfrotation,  'X3DField';
isa_ok $testNode->mfstring,    'X3DField';
isa_ok $testNode->mftime,      'X3DField';
isa_ok $testNode->mfvec2d,     'X3DField';
isa_ok $testNode->mfvec2f,     'X3DField';
isa_ok $testNode->mfvec3d,     'X3DField';
isa_ok $testNode->mfvec3f,     'X3DField';
isa_ok $testNode->mfvec4d,     'X3DField';
isa_ok $testNode->mfvec4f,     'X3DField';

isa_ok $testNode->sfbool,      'X3DField';
isa_ok $testNode->sfcolor,     'X3DField';
isa_ok $testNode->sfcolorrgba, 'X3DField';
isa_ok $testNode->sfdouble,    'X3DField';
isa_ok $testNode->sffloat,     'X3DField';
isa_ok $testNode->sfimage,     'X3DField';
isa_ok $testNode->sfint32,     'X3DField';
isa_ok $testNode->sfnode,      'X3DField';
isa_ok $testNode->sfrotation,  'X3DField';
isa_ok $testNode->sfstring,    'X3DField';
isa_ok $testNode->sftime,      'X3DField';
isa_ok $testNode->sfvec2d,     'X3DField';
isa_ok $testNode->sfvec2f,     'X3DField';
isa_ok $testNode->sfvec3d,     'X3DField';
isa_ok $testNode->sfvec3f,     'X3DField';
isa_ok $testNode->sfvec4d,     'X3DField';
isa_ok $testNode->sfvec4f,     'X3DField';

isa_ok my $vec3f = $testNode->sfvec3f, 'SFVec3f';
ok !tied $vec3f;

ok tied $testNode->mfbool;
ok tied $testNode->mfcolor;
ok tied $testNode->mfcolorrgba;
ok tied $testNode->mfdouble;
ok tied $testNode->mffloat;
ok tied $testNode->mfimage;
ok tied $testNode->mfint32;
ok tied $testNode->mfnode;
ok tied $testNode->mfrotation;
ok tied $testNode->mfstring;
ok tied $testNode->mftime;
ok tied $testNode->mfvec2d;
ok tied $testNode->mfvec2f;
ok tied $testNode->mfvec3d;
ok tied $testNode->mfvec3f;
ok tied $testNode->mfvec4d;
ok tied $testNode->mfvec4f;

ok tied $testNode->sfbool;
ok tied $testNode->sfcolor;
ok tied $testNode->sfcolorrgba;
ok tied $testNode->sfdouble;
ok tied $testNode->sffloat;
ok tied $testNode->sfimage;
ok tied $testNode->sfint32;
ok tied $testNode->sfnode;
ok tied $testNode->sfrotation;
ok tied $testNode->sfstring;
ok tied $testNode->sftime;
ok tied $testNode->sfvec2d;
ok tied $testNode->sfvec2f;
ok tied $testNode->sfvec3d;
ok tied $testNode->sfvec3f;
ok tied $testNode->sfvec4d;
ok tied $testNode->sfvec4f;

ok !tied ${ tied $testNode->mfbool };
ok !tied ${ tied $testNode->mfcolor };
ok !tied ${ tied $testNode->mfcolorrgba };
ok !tied ${ tied $testNode->mfdouble };
ok !tied ${ tied $testNode->mffloat };
ok !tied ${ tied $testNode->mfimage };
ok !tied ${ tied $testNode->mfint32 };
ok !tied ${ tied $testNode->mfnode };
ok !tied ${ tied $testNode->mfrotation };
ok !tied ${ tied $testNode->mfstring };
ok !tied ${ tied $testNode->mftime };
ok !tied ${ tied $testNode->mfvec2d };
ok !tied ${ tied $testNode->mfvec2f };
ok !tied ${ tied $testNode->mfvec3d };
ok !tied ${ tied $testNode->mfvec3f };
ok !tied ${ tied $testNode->mfvec4d };
ok !tied ${ tied $testNode->mfvec4f };

ok !tied ${ tied $testNode->sfbool };
ok !tied ${ tied $testNode->sfcolor };
ok !tied ${ tied $testNode->sfcolorrgba };
ok !tied ${ tied $testNode->sfdouble };
ok !tied ${ tied $testNode->sffloat };
ok !tied ${ tied $testNode->sfimage };
ok !tied ${ tied $testNode->sfint32 };
ok !tied ${ tied $testNode->sfnode };
ok !tied ${ tied $testNode->sfrotation };
ok !tied ${ tied $testNode->sfstring };
ok !tied ${ tied $testNode->sftime };
ok !tied ${ tied $testNode->sfvec2d };
ok !tied ${ tied $testNode->sfvec2f };
ok !tied ${ tied $testNode->sfvec3d };
ok !tied ${ tied $testNode->sfvec3f };
ok !tied ${ tied $testNode->sfvec4d };
ok !tied ${ tied $testNode->sfvec4f };

1;
__END__



